import { LifeCycle } from 'miniprogram-network-life-cycle';
import { WxQueue } from 'miniprogram-queue';
import { transfomDownloadSendDefault } from './transform';
// tslint:disable-next-line: no-use-before-declare
var downloadQueue = new WxQueue(wx.downloadFile);
/**
 * 下载封装
 */
var Downloader = /** @class */ (function (_super) {
    __extends(Downloader, _super);
    /**
     * 新建 Http实列
     * @param config 全局默认配置
     */
    function Downloader(config, downloader) {
        return _super.call(this, downloader || downloadQueue.push.bind(downloadQueue), config || { transformSend: transfomDownloadSendDefault }) || this;
    }
    Downloader.prototype.download = function () {
        var isMultiParam = typeof arguments[0] === 'string';
        var options = isMultiParam ? (arguments[2] || {}) : arguments[0];
        if (isMultiParam) {
            options.url = arguments[0];
            options.filePath = arguments[1];
        }
        return this.process(options);
    };
    return Downloader;
}(LifeCycle));
export { Downloader };
//# sourceMappingURL=downloader.js.map